;*********** WINDLX Ex.2: Matrix multiplication          *********
;*********** (c) 1998 Milos Becvar			 *************
;*********** Data are stored in memory, result too       *************

		; Start of data segment
		.data
		; 		 
Adata:		.byte		1,2,3,4,5,6,7,8,9
		; rows
Bdata:		.byte		1,0,0,0,1,0,0,0,1
		; columns
Result:		.space		18	
		; 3*3*2	

Size:		.byte		3 
		; size of matrix

		; Start of code segment
		.text
		
Start:		lhi		r1,Adata>>16
		addui		r1,r1,Adata&0xffff ; base adress of matrix A
		lhi		r2,Bdata>>16
		addui		r2,r2,Bdata&0xffff ; base adress of matrix B
		lhi		r3,Result>>16	
		addui		r3,r3,Result&0xffff ; base adress of result matrix
		lbu		r4,Size		    ; matrix dimens.				
		lbu		r5,Size		    ; matrix dim.	
cycle1:		lbu		r6,0(r1)		
		lbu		r7,1(r1)
		lbu		r8,2(r1)		; A row
cycle2:		lbu		r9,0(r2)
		lbu		r10,1(r2)
		lbu		r11,2(r2)		; B column
		multu		r12,r6,r9
		multu		r13,r7,r10
		multu		r14,r8,r11
		addu		r12,r12,r13
		addu		r12,r12,r14
		sh		0(r3),r12		; store result
		addui		r2,r2,3			; next column		
		addui		r3,r3,2			; next result
		subui		r5,r5,1			; decr. count cycle 2
		bnez		r5,cycle2		; cond. branch
		lbu		r5,Size			; count for cycle 2
		subui		r2,r2,9			; column 0
		subui		r4,r4,1			; decr. count cycle 1
		addui		r1,r1,3			; next row
		bnez		r4,cycle1		; cond. branch cycle 1
		
